uniform sampler2D texture0;

varying vec2 texcoord;

void main(void) {
	
	float d = length(texcoord - 0.5) / 0.5;
	float h = texture2D( texture0,vec2( texcoord.x, 1.0 - texcoord.y ) ).x;
	
	if (d>0.25) {
		if (d<0.75) {
			d=clamp( (d-0.25) / 0.5, 0.0, 1.0);
			d= ( sin( (d*1.0-0.5)*3.14159265 ) * 0.5 + 0.5 ) * 0.75;
			d+=0.25;
		}
		else {
			d=1.0;
		}
	}
	else {
		d=0.25;
	}
	gl_FragColor = vec4(d*h);
}