Include "abstract::GetTerrainHeight.vert"

//uniform mat4 meshmatrix;
uniform vec2 meshlayeroffset;
uniform float meshlayerscale;
uniform float meshlayersize;
uniform float meshlayersectorsize;

uniform float instancepasssize;

uniform sampler2D texture10;

#ifdef LW_INSTANCED
	#ifndef LW_SKIN
		#extension GL_EXT_gpu_shader4 : enable
		//#extension GL_EXT_bindable_uniform : enable
		//bindable uniform mat4 instancematrix[ LW_MAX_PASS_SIZE ];
		uniform mat4 instancematrix[ LW_MAX_PASS_SIZE ];
	#else
		//uniform mat4 animmatrix[69];
		uniform mat4 instancematrix[1];
	#endif
#else
	uniform mat4 instancematrix[1];
#endif

#ifdef LW_SKIN

attribute vec4 boneindices;
uniform float bonecount;

mat4 GetAnimMatrix( in int i ) {
	//return animmatrix[i];
	
	mat4 mat;

	float f=i;
	f+=0.5;
	
	mat[0]=texture2D(texture10,vec2( 0.5/64.0, f/bonecount ));
	mat[1]=texture2D(texture10,vec2( 1.5/64.0, f/bonecount ));
	mat[2]=texture2D(texture10,vec2( 2.5/64.0, f/bonecount ));
	mat[3]=texture2D(texture10,vec2( 3.5/64.0, f/bonecount ));		

	return mat;
}

#endif
