/********************************************************************************************************************************
* By Hau Nghiep Phan 19/08/2008

put this in declaration:
	postDistortFilterT:TTexture = loadtexture("abstract::post_distort_N.dds")
	If Not CDpostfilter CDpostfilter=LoadShader("abstract::postfilter.vert","abstract::chromaticDisp.frag")
	
put this before flip() and should be after drawing the scene
	SetBuffer postbuffer		'set this if you have Motion blur after this shader
	SetBuffer BackBuffer()		'set this if theres no motion blur after this
	SetShader CDPostfilter
	postDistortFilterT.bind(1)
	DrawImage postbuffer.colorbuffer[0],0,GraphicsHeight(),GraphicsWidth(),-GraphicsHeight()

********************************************************************************************************************************/

#define BlurStrength 0.1
uniform float AppTime;

uniform sampler2D texture0; //color
uniform sampler2D texture1; //perturbation
uniform vec3 timeEvent;	// for water splash

varying vec2 texCoord;
vec2 motionblurtexcoord = texCoord;
vec3 Temporal;

void main( void ) 
{

	timeEvent *= BlurStrength;
	Temporal.r = texture2D(texture1,texCoord+vec2(0,AppTime/100000)).r*timeEvent.r;
	Temporal.g = texture2D(texture1,texCoord+vec2(0,AppTime/910000)).g*timeEvent.g;
	Temporal.b = texture2D(texture1,texCoord+vec2(0,AppTime/950000)).b*timeEvent.b;
	motionblurtexcoord = (motionblurtexcoord.rg+Temporal.r)-timeEvent.r/2.0;
	motionblurtexcoord = (motionblurtexcoord.rg+Temporal.g)-timeEvent.g/2.0;
	motionblurtexcoord = (motionblurtexcoord.rg+Temporal.b)-timeEvent.b/2.0;

	//motionblurtexcoord += vec2(.5,.5);
	//gl_FragColor = texture2D( texture0, motionblurtexcoord+vec2(.5,.5));
	gl_FragColor.r = texture2D( texture0, motionblurtexcoord+vec2(.5,.5)).r;
	gl_FragColor.g = texture2D( texture0, motionblurtexcoord*1.002+vec2(.5,.5)).g;
	gl_FragColor.b = texture2D( texture0, motionblurtexcoord*0.998+vec2(.5,.5)).b;
}
