#define samples 10.0
#define samplesi 10

uniform sampler2D texture0;
uniform vec2 buffersize;

void main( void ) {
	vec2 ps = 1.0 / buffersize;
	vec4 color;
	vec2 coord;
	for ( int i = 0; i < samplesi; i++ ) {
		coord.x=gl_FragCoord.x/buffersize.x;
		coord.y=gl_FragCoord.y/buffersize.y-ps.y*samples*0.5+i*ps.y;
		vec4 bloom = texture2D(texture0,coord);
		bloom *= bloom.w;
		color += bloom;
	//	color += texture2D(texture0,coord);
	}
	gl_FragColor = color/samples;	
}