vec3 screenlightcoord=screenlightpos;
vec2 deltaTexCoord = ( screenlightcoord.xy - texcoord );

deltaTexCoord *= sign(screenlightpos.z);

float length = length( deltaTexCoord );
deltaTexCoord /= length;
length = min(length,MAXRAYLENGTH);
deltaTexCoord *= length;

vec2 godraycoord = texcoord;// make a modifiable variable	

float d;

if ((texcoord.x + deltaTexCoord.x - 1.0) > 0.0) {
	d = (1.0 - godraycoord.x)/deltaTexCoord.x;
	deltaTexCoord *= d;	
}
if ((texcoord.y + deltaTexCoord.y - 1.0) > 0.0) {
	d = (1.0 - godraycoord.y)/deltaTexCoord.y;
	deltaTexCoord *= d;
}	
if ((texcoord.x + deltaTexCoord.x) < 0.0) {
	d = godraycoord.x/-deltaTexCoord.x;
	deltaTexCoord *= d;
}
if ((texcoord.y + deltaTexCoord.y)<0.0) {
	d = godraycoord.y/-deltaTexCoord.y;
	deltaTexCoord *= d;
}

deltaTexCoord /= RAYSAMPLES;

float illuminationDecay = 1.0;

vec4 sample;
float weight = 1.0;
float decay = 1.0;

vec4 lightcolor;

float b;
float godray = 0.0;
float avg=0.0;

float ok=0.0;

vec2 dc;
float dd;

for ( int i = 0; i < RAYSAMPLES; i++ ) {
	godraycoord += deltaTexCoord;
	godray += illuminationDecay * int(texture2D( texture1, godraycoord ).x);
	illuminationDecay *= decay;
	//dc=godraycoord-screenlightcoord.xy;
	//dd=sqrt(dc.x*dc.x+dc.y*dc.y);
	//dd=1.0-clamp(0.05-dd,0.0,1.0);
	//ok=1.0;
	//ok=max(ok,dd);
}
godray /= RAYSAMPLES;
godray *= exposure;


//Darken the ray if it is in the foreground and camera faces away from light source
//Enable the depth check if you want rays to appear when facing away from the camera.
//However, due to the reduced size buffer, this will cause jaggies to appear along the skyline
//so I commented it out.  :(
//if (depth<1.0) {
	godray = godray * max(-lightvector.z,0.0);
//}

outputcolor = raycolor * godray;