uniform sampler2D texture0;
uniform vec2 buffersize;

varying vec4 fragcolor;

void main(void) {
	vec2 texcoord = gl_FragCoord.xy / buffersize;
	vec4 outcolor = vec4(texture2D(texture0,texcoord).xyz,fragcolor.a);
	//outcolor *= outcolor.w;
	outcolor.x = clamp(outcolor.x,0,2);
	outcolor.y = clamp(outcolor.y,0,2);
	outcolor.z = clamp(outcolor.z,0,2);
	outcolor.w = clamp(outcolor.w,0,2);
	gl_FragData[0] = outcolor;
}
