//outputcolor=vec4(0.35);

float gray = outputcolor.r * 0.3 + outputcolor.g * 0.59 + outputcolor.b * 0.11;

vec2 noisecoord = texcoord;
vec2 noise = (texture2D(texture10,texcoord.xy*10.0).xy - 0.5 )*2.0 * 0.01;
//noisecoord.x += noise.x * 0.005;//cos(angle)*0.005;
//noisecoord.y += noise.y * 0.005*(buffersize.y/buffersize.x); //sin(angle)*0.01*(buffersize.y/buffersize.x);

noise.y *= buffersize.y/buffersize.x;

if (gray<10.5) {

	float aodiv = 1.2;

	float depth = readDepth( noisecoord );
	float d;
	
	float pw = 4.0 / buffersize.x;
	float ph = 4.0 / buffersize.y;
	vec2 ps = vec2(pw,ph) + noise;

	float aoCap = 1.0;

	float ao = 0.0;
	
	float aoMultiplier=10000.0;

	float depthTolerance = 0.001;
	
	float aoscale=1.0;

	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;
	
	//pw*=2.0;
	//ph*=2.0;
	pw+=ps.x;
	ph+=ps.y;
	aoMultiplier/=2.0;
	aoscale*=aodiv;
	
	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;

	//pw*=2.0;
	//ph*=2.0;
	pw+=ps.x;
	ph+=ps.y;
	aoMultiplier/=2.0;
	aoscale*=aodiv;
	
	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;

	/*	
	pw+=ps.x;
	ph+=ps.y;
	aoMultiplier/=2.0;
	aoscale*=aodiv;
	
	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y+ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x+pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;

	d=readDepth( vec2(noisecoord.x-pw,noisecoord.y-ph));
	ao+=compareDepths(depth,d)/aoscale;
	*/

	ao/=12.0;
	ao=clamp(ao,0.0,0.5);


	float l=max(0.0,(gray-0.3)/0.2);
	//float l=max(0.0,(gray-0.2)/0.8);
	outputcolor = (1.0-l) * vec4(1.0-ao) * outputcolor + l * outputcolor;


	//outputcolor = (1.0-l) * vec4(1.0-ao);
}