//#ifdef __GLSL_CG_DATA_TYPES



// NVidia
#if LW_SHADOWQUALITY==3
	shadowcolor = shadow2D(texture4,smcoord);
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor = shadow2D(texture8,smcoord);
		lighttint = texture2D(texture6,smcoord.xy);
	#endif
#endif

#if LW_SHADOWQUALITY==2
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.0).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor = shadow2D(texture4,smcoord+vec3(noise,0.0));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor = shadow2D(texture8,smcoord+vec3(noise,0.0));
		lighttint = texture2D(texture6,smcoord.xy+noise);
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.125).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(smcoord.x+psx+noise.x,smcoord.y+noise.y,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(smcoord.x+psx+noise.x,smcoord.y+noise.y,smcoord.z));
		lighttint += texture2D(texture6,vec2(smcoord.x+psx+noise.x,smcoord.y+noise.y));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.25).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(smcoord.x-psx+noise.x,smcoord.y+noise.y,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(smcoord.x+psx+noise.x,smcoord.y+noise.y,smcoord.z));
		lighttint += texture2D(texture6,vec2(smcoord.x-psx+noise.x,smcoord.y+noise.y));
	#endif

	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.5).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(smcoord.x+noise.x,smcoord.y+psy+noise.y,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(smcoord.x+psx+noise.x,smcoord.y+noise.y,smcoord.z));
		lighttint += texture2D(texture6,vec2(smcoord.x+noise.x,smcoord.y+psy+noise.y));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.75).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(smcoord.x+noise.x,smcoord.y-psy+noise.y,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(smcoord.x+psx+noise.x,smcoord.y+noise.y,smcoord.z));
		coloredshadowcolor /= 5.0;
		lighttint += texture2D(texture6,vec2(smcoord.x+noise.x,smcoord.y-psy+noise.y));
		lighttint /= 5.0;
	#endif
	
	shadowcolor/=5.0;
	
#endif

#if LW_SHADOWQUALITY==1
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.125).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor = shadow2D(texture4,vec3(noise,0.0)+smcoord);
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor = shadow2D(texture8,vec3(noise,0.0)+smcoord);
		lighttint += texture2D(texture6,noise.xy);
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.25).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x+psx,noise.y+smcoord.y,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x+psx,noise.y+smcoord.y,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x+psx,noise.y+smcoord.y));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.375).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x-psx,noise.y+smcoord.y,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x-psx,noise.y+smcoord.y,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x-psx,noise.y+smcoord.y));
	#endif

	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.5).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x,noise.y+smcoord.y+psy,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x,noise.y+smcoord.y+psy,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x,noise.y+smcoord.y+psy));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.625).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x,noise.y+smcoord.y-psy,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x,noise.y+smcoord.y-psy,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x,noise.y+smcoord.y-psy));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.75).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x+psx,noise.y+smcoord.y+psy,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x+psx,noise.y+smcoord.y+psy,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x+psx,noise.y+smcoord.y+psy));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.875).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x-psx,noise.y+smcoord.y+psy,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x-psx,noise.y+smcoord.y+psy,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x-psx,noise.y+smcoord.y+psy));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.92).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x-psx,noise.y+smcoord.y-psy,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x-psx,noise.y+smcoord.y-psy,smcoord.z));
		lighttint += texture2D(texture6,vec2(noise.x+smcoord.x-psx,noise.y+smcoord.y-psy));
	#endif
	
	noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.0).xy - 0.5) * 2.0 * shadowjitter_;
	shadowcolor += shadow2D(texture4,vec3(noise.x+smcoord.x+psx,noise.y+smcoord.y-psy,smcoord.z));
	#ifdef LW_LIGHTTEXTURE
		coloredshadowcolor += shadow2D(texture8,vec3(noise.x+smcoord.x+psx,noise.y+smcoord.y-psy,smcoord.z));
		coloredshadowcolor /= 9.0;
		lighttint += texture2D(texture6,smcoord.xy);
		lighttint /= 9.0;
	#endif
	
	shadowcolor/=9.0;
	
#endif

#ifdef LW_LIGHTTEXTURE
	lighttint += texture2D(texture6,vec2(smcoord.x,smcoord.y));
	lighttint = texture2D(texture6,smcoord.xy);//vec4(0,1,0,1);
	lighttint = lighttint * (1.0-coloredshadowcolor.x) + vec4(1.0) * coloredshadowcolor.x;
#endif

//shadowcolor=vec4(1);

/*
#else
	
	sw = 1.0/psx;
	sh = 1.0/psy;

	// ATI
	#if LW_SHADOWQUALITY==3
		shadowcolor = shadow2D4(texture4,smcoord,sw,sh).x;
	#endif
	
	#if LW_SHADOWQUALITY==2

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.0).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor = shadow2D4(texture4,vec3(noise,0.0)+smcoord,sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.2).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x+psx,noise.y + smcoord.y,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.4).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x-psx,noise.y + smcoord.y,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.6).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x,noise.y + smcoord.y+psy,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.8).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x,noise.y + smcoord.y-psy,smcoord.z),sw,sh).x;

		shadowcolor /= 5.0;
	#endif
		
	#if LW_SHADOWQUALITY==1
		
		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.0).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor = shadow2D4(texture4,vec3(noise,0.0) + smcoord,sw,sh).x;
		
		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.125).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x+psx,noise.y + smcoord.y,smcoord.z),sw,sh).x;
		
		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.25).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x-psx,noise.y + smcoord.y,smcoord.z),sw,sh).x;
		
		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.375).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x,noise.y + smcoord.y+psy,smcoord.z),sw,sh).x;
		
		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.5).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x,noise.y + smcoord.y-psy,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.625).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x+psx,noise.y + smcoord.y+psy,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.75).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x-psx,noise.y + smcoord.y+psy,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.875).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x-psx,noise.y + smcoord.y-psy,smcoord.z),sw,sh).x;

		noise = (texture2D(texture5,gl_FragCoord.xy/buffersize*10.0+0.93).xy - 0.5) * 2.0 * shadowjitter_;
		shadowcolor += shadow2D4(texture4,vec3(noise.x + smcoord.x+psx,noise.y + smcoord.y-psy,smcoord.z),sw,sh).x;

		shadowcolor /= 9.0;
	#endif

#endif
*/