uniform vec3 terrainscale;
uniform sampler2D texture15;
uniform float terrainsize;

float GetTerrainHeight( in vec2 position ) {
	float terrainresolution = terrainsize/terrainscale.x;
	vec2 texcoord;
	float pixelsize = 1.0 / terrainresolution;
	texcoord = position.xy / terrainsize + 0.5;
	texcoord += 0.5 * pixelsize;
	return texture2D( texture15, texcoord ).x * terrainscale.y;
}
