Include "meshmatrix.vert"

uniform float aspect;

varying vec4 projectSpace;
varying vec2 texcoord;
varying vec3 T,B,N;
varying vec4 ModelVertex;
uniform mat4 MeshMatrix;
uniform vec2 buffersize;
uniform vec4 options;

//varying vec3 reflectdir;

void main(){
	
	Include "getmatrix.vert"
		
	mat3 nmat = mat3(mat[0].xyz,mat[1].xyz,mat[2].xyz);
	ModelVertex = gl_Vertex;
	ModelVertex = mat * ModelVertex;
	
	gl_FrontColor=gl_Color;
	projectSpace = gl_ModelViewProjectionMatrix * mat * gl_Vertex;  
	gl_Position = projectSpace;
	//projectSpace.x *	= options.x + 0.0;//(buffersize.x / buffertexsize.x);
	//projectSpace.x = projectSpace.x*0.75+0.125;	
	
	projectSpace.xy = (projectSpace.xy + vec2(projectSpace.w)) * 0.5;

	//projectSpace.y += 0.25;
	texcoord=gl_MultiTexCoord0.xy;
	
	T = gl_NormalMatrix * (nmat *  gl_MultiTexCoord2.xyz);
	B = gl_NormalMatrix * (nmat *  gl_MultiTexCoord3.xyz);
	N = gl_NormalMatrix * (nmat *  gl_Normal);
	//reflectdir = gl_NormalMatrix * vec3(0.0,1.0,0.0);
}
