Include "MeshMatrix.vert"

uniform vec3 cameraposition;

varying vec3 cubecoord;

varying vec4 fragcolor;

void main(void) {
	
	Include "GetMatrix.vert"
	
	vec4 modelvertex = mat * gl_Vertex;
	gl_Position = gl_ModelViewProjectionMatrix * modelvertex;
	cubecoord = modelvertex.xyz - cameraposition;
	fragcolor = gl_Color * color;
	
	#ifdef __GLSL_CG_DATA_TYPES
		gl_ClipVertex = gl_ModelViewMatrix * modelvertex;
	#endif

}
