/********************************************************************************************************************************
* By Hau Nghiep Phan 19/08/2008

* Dont forget to use CameraMotionBlur.vert
* You can also pass a texture for any HUD you'd like ;)
* just uncomment the commands and pass the postNoiseFilterT texture to the shader

source in BMax:

put this in value declarations if you want to draw HUDs:
'		postNoiseFilterT:TTexture = loadtexture("abstract::post_Noise_D.dds")

put this in your game loop, you can use the speed of your character instead of passing keydown() function:
		If Not MBlurpostfilter MBlurpostfilter=LoadShader("abstract::CameraMotionBlur.vert","abstract::CameraMotionBlur.frag")
		SetShader MBlurpostfilter 
		Local camerarotation:tvec3 = entityrotation(camera)
		Local mx:Float = camerarotation.x - OldCameraRotation.x
		Local my:Float = camerarotation.y - OldCameraRotation.y
		SetShaderVec2 MBlurpostfilter ,"motionblurvector",vec2(-my/2500.0 ,-mx/2500.0)
		SetShaderfloat MBlurpostfilter ,"rndS",Rnd(0,2) 
		Local runmode
		If KeyDown(KEY_LSHIFT) Or KeyDown(KEY_RSHIFT) runmode=2 Else runmode=1
		SetShaderVec3 MBlurpostfilter ,"BlurWidth",vec3((KeyDown(KEY_D)-KeyDown(KEY_A))*.0003*runmode,0,(KeyDown(KEY_W)-KeyDown(KEY_S))*-.02*runmode)
		OldCameraRotation = camerarotation

put this before flip() and should be after drawing the scene
		SetBuffer BackBuffer()
		SetShader MBlurPostfilter
		postbuffer.colorbuffer[0].bind(0)
'		postNoiseFilterT.bind(1)
		DrawImage postbuffer.colorbuffer[0],0,GraphicsHeight(),GraphicsWidth(),-GraphicsHeight()
*********************************************************************************************************************************/

#define motionblursamples 10.0

varying vec2 texCoord;
uniform sampler2D texture0; //color
uniform vec2 motionblurvector;//=vec2(.001,0);
uniform vec2 buffersize;
uniform vec3 blurwidth;
uniform float rndS;
uniform sampler2D texture1; //noise n stuff

void main( void ) {
	vec2 motionblurtexcoord = texCoord;
	vec4 motionblur;
	float scale;
	for ( int i = 0; i < 10; i++ ) 
	{
	  	//scale = 1.0 + blurwidth.z*(i/float(motionblursamples-1.0));
		motionblurtexcoord += motionblurvector;	// set dependent on FPS
		//motionblurtexcoord.x += blurwidth.x;
		motionblur += texture2D( texture0, motionblurtexcoord );
	}
	gl_FragColor =  motionblur / 10.0;//*1.15;
	//gl_FragColor = texture2D( texture0, texCoord );

	//gl_FragColor *= texture2D( texture1, texCoord+vec2(.5,.5)).a;	// vignetting
	//gl_FragColor -= texture2D( texture1, (texCoord*3+rndS)).g/((gl_FragColor.r+gl_FragColor.g+gl_FragColor.b));		// noise
	//gl_FragColor *= texture2D( texture1, texCoord+vec2(.5,.5)).r;	// HUD1
	//gl_FragColor -= texture2D( texture1, texCoord+vec2(.5,.5)).b;	// HUD2 //cross hair
}