vec3 screencoord;
vec4 caustics;
vec2 causticscoord;

screencoord = vec3(((gl_FragCoord.x/buffersize.x)-0.5) * 2.0,((-gl_FragCoord.y/buffersize.y)+0.5) * 2.0 / (buffersize.x/buffersize.y),lineardepth);
screencoord.x *= screencoord.z / camerazoom;
screencoord.y *= -screencoord.z / camerazoom;	
causticscoord.x = dot(causticsmappingaxes[0].xyz,screencoord) + causticsmappingaxes[0].w;
causticscoord.y = dot(causticsmappingaxes[1].xyz,screencoord) + causticsmappingaxes[1].w;
caustics = (1.0-causticsframeinterpolation)*texture2D(texture5,causticscoord) + (causticsframeinterpolation)*texture2D(texture7,causticscoord);

caustics *= causticscolor;
caustics *= clamp( dot(causticsmappingaxes[2].xyz,screencoord)+causticsmappingaxes[2].w,0.0,1.0);
caustics *= clamp( dot( vec3(-normal.x,-normal.y,normal.z), causticsmappingaxes[3].xyz ), 0.0, 1.0 );
caustics *= 2.0;

outputcolor += caustics;
