uniform sampler2D texture0;
varying vec2 texcoord;
uniform vec2 buffersize;

#define samples 10

void main( void ) {
	float ps = 1.0 / buffersize.x;
	vec4 color;
	for ( int i = 0; i < samples; i++ ) {
		color+=tex2D(texture0,vec2(texcoord.x,texcoord.y-ps*samples*0.5+i*ps));
	}
	gl_FragColor = color/samples;	
}