uniform vec3 terrainscale;
uniform float terrainsize;

varying vec3 texcoord0;
varying vec2 texcoord1;
varying vec3 T,B;
varying vec3 vertexposition;

void main(void) {
	
	float terrainresolution = terrainsize / terrainscale.x;
	
	texcoord0=gl_MultiTexCoord0.xzy * terrainsize;
	texcoord1=vec2(gl_MultiTexCoord0.x,1.0-gl_MultiTexCoord0.y);
	texcoord0 += terrainresolution * 0.5 * terrainscale;
	texcoord0.z = -texcoord0.z;
	gl_Position = ftransform();
	T = vec3(1.0,0.0,0.0);
	B = vec3(0.0,-1.0,0.0);
	vertexposition=vec3(0);
}
