include "abstract::meshmatrix.vert"

varying vec3 vertexposition;

void main(void) {
	
	include "abstract::getmatrix.vert"
	
	vec4 v = vec4( gl_Vertex.x, 0.0, gl_Vertex.z, 1.0 );
	
	v.x = v.x*terrainscale.x+mat[3].x;
	v.z = v.z*terrainscale.z+mat[3].z;
	v.y = GetTerrainHeight(v.xz);
	
	vertexposition = v.xyz;
	
	gl_Position = gl_ModelViewProjectionMatrix * v;
	
}
